/*
 * Memory sharing abstractions.
 *
 * Copyright (C) 2018, 2019, 2021, 2022 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/re/c/dataspace.h>
#include <l4/re/c/rm.h>
#include <l4/sys/types.h>

EXTERN_C_BEGIN

long ipc_allocate(unsigned long size, void **addr, l4re_ds_t *ds);

long ipc_allocate_align(unsigned long size, l4re_rm_flags_t flags,
                        unsigned char align, void **addr, l4re_ds_t *ds);

long ipc_new_dataspace(l4_mword_t size, l4_umword_t flags, l4_umword_t align,
                       l4re_ds_t *ds);

long ipc_attach_dataspace(l4re_ds_t ds, unsigned long size, void **addr);

long ipc_attach_dataspace_align(l4re_ds_t ds, unsigned long size,
                                l4re_rm_flags_t flags, unsigned char align,
                                void **addr);

long ipc_detach_dataspace(void *addr);

long ipc_dataspace_size(l4_cap_idx_t cap, unsigned long *size);

EXTERN_C_END

/* vim: tabstop=2 expandtab shiftwidth=2
*/
